//+------------------------------------------------------------------+
#property copyright "Copyright  2011,"
#include <stdlib.mqh>

#define SIGNAL_NONE        0 
#define UP                 1 
#define DOWN               2
#define SIGNAL_BUY         3 
#define SIGNAL_SELL        4 
#define SIGNAL_CLOSEBUY    5
#define SIGNAL_CLOSESELL   6 
#define NONE               7 

extern string    separator1 = "------trend settings------";
extern int       barsInTrend = 1;                  // how many bars should be in trend

extern string    separator1a = "------Trading Time settings------";
extern bool      AllowTradesByTime = false;         // Trading Time Allowed
extern int       Start_Time = 2;                   // Time to allow trading to start ( hours of 24 hr clock ) 0 for both disables
extern int       Finish_Time = 17;                 // Time to stop trading ( hours of 24 hr clock ) 0 for both disables

extern string    separator2 = "------position settings------";
extern double    Buylots = 0.01;                     // fixed lot size
extern double    Selllots = 0.01;                     // fixed lot size
extern int       BuymaxTrades = 1;                   // max trades allowed for pyramiding
extern int       SellmaxTrades = 1;                   // max trades allowed for pyramiding
extern double    stop_loss = 200;                   // stop loss
extern double    take_profitT = 500;                // take profit
extern double    take_profit = 500;                // take profit
extern bool      useTrailingStop = True;          // use trailing stop
extern double    trailing_stop = 350;               // trail stop loss
extern bool      useUnprofitExit = True;          // exit trade when trade was not in profit in defined amount of bars
extern int       maxUnprofitBars = 5;              // amount of bars not in profit
extern string    symb;
extern bool	PopupAlert        	= true;
extern bool SendPushNotification = false;
extern bool SoundAlert           = false;
extern string SoundFileLong      = "alert.wav";
extern string SoundFileShort     = "alert2.wav";
int lastAlert=3;
 
extern string    separator4 = "------Sleep settings------";
extern bool      useSleepAfterClosed = False;       // Put to sleep for 30 minit after closing order

extern double    magicNumber = 0;

double stopLoss, takeProfitT, takeProfit, trailingStop;
int             MyPoint=1;

bool buyBE, sellBE;
bool TrendOpen, TrendClosed;
bool EntryBuy, EntrySell;

double signal_Buy1;
double signal_Buy2;
double signal_Buy3;
double signal_Sell1;
double signal_Sell2;
double signal_Sell3;

double minAllowedLot, lotStep, maxAllowedLot;

int unprofitBars=0;
int Order = SIGNAL_NONE;
int slipageOrder = 3, slipageClose = 5;

double pips2dbl;
datetime barTime=0;
static datetime barTimeM5; 

int flag, count;
bool dselect,dclosed,dmodify;

string GV_euraud, GV_eurnzd, GV_eurjpy, GV_eurusd, GV_eurcad;
string GV_gbpaud, GV_gbpnzd, GV_gbpjpy, GV_gbpusd, GV_gbpcad;

int gv_euraud, gv_eurnzd, gv_eurjpy, gv_eurusd, gv_eurcad;
int gv_gbpaud, gv_gbpnzd, gv_gbpjpy, gv_gbpusd, gv_gbpcad;

string GVTA_euraud, GVTA_eurnzd, GVTA_eurjpy, GVTA_eurusd, GVTA_eurcad;
string GVTA_gbpaud, GVTA_gbpnzd, GVTA_gbpjpy, GVTA_gbpusd, GVTA_gbpcad;

int gvta_euraud, gvta_eurnzd, gvta_eurjpy, gvta_eurusd, gvta_eurcad;
int gvta_gbpaud, gvta_gbpnzd, gvta_gbpjpy, gvta_gbpusd, gvta_gbpcad;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   //Comment("Copyright  2011");
   
  
  if(MarketInfo(symb,MODE_DIGITS)==3||MarketInfo(symb,MODE_DIGITS)==5)MyPoint=10; else MyPoint=1; 

   if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
   {            
      pips2dbl = Point*10;
   } 
   else 
   {    
      pips2dbl = Point;   
   }
   
   stopLoss       = pips2dbl*stop_loss;
   takeProfit    = pips2dbl*take_profit;
   trailingStop   = pips2dbl*trailing_stop;
//------------------------------

if (!GlobalVariableCheck("GV_euraud")) GlobalVariableSet("GV_euraud",0);
if (!GlobalVariableCheck("GV_eurnzd")) GlobalVariableSet("GV_eurnzd",0);
if (!GlobalVariableCheck("GV_eurusd")) GlobalVariableSet("GV_eurusd",0);
if (!GlobalVariableCheck("GV_eurjpy")) GlobalVariableSet("GV_eurjpy",0);
if (!GlobalVariableCheck("GV_gbpaud")) GlobalVariableSet("GV_gbpaud",0);
if (!GlobalVariableCheck("GV_gbpnzd")) GlobalVariableSet("GV_gbpnzd",0);
if (!GlobalVariableCheck("GV_gbpusd")) GlobalVariableSet("GV_gbpusd",0);
if (!GlobalVariableCheck("GV_gbpjpy")) GlobalVariableSet("GV_gbpjpy",0);

if (!GlobalVariableCheck("GVTA_euraud")) GlobalVariableSet("GVTA_euraud",0);
if (!GlobalVariableCheck("GVTA_eurnzd")) GlobalVariableSet("GVTA_eurnzd",0);
if (!GlobalVariableCheck("GVTA_eurusd")) GlobalVariableSet("GVTA_eurusd",0);
if (!GlobalVariableCheck("GVTA_eurjpy")) GlobalVariableSet("GVTA_eurjpy",0);
if (!GlobalVariableCheck("GVTA_gbpaud")) GlobalVariableSet("GVTA_gbpaud",0);
if (!GlobalVariableCheck("GVTA_gbpnzd")) GlobalVariableSet("GVTA_gbpnzd",0);
if (!GlobalVariableCheck("GVTA_gbpusd")) GlobalVariableSet("GVTA_gbpusd",0);
if (!GlobalVariableCheck("GVTA_gbpjpy")) GlobalVariableSet("GVTA_gbpjpy",0);

/*   
   minAllowedLot  =  MarketInfo(Symbol(), MODE_MINLOT);    //IBFX= 0.10
   lotStep        =  MarketInfo(Symbol(), MODE_LOTSTEP);   //IBFX= 0.01
   maxAllowedLot  =  MarketInfo(Symbol(), MODE_MAXLOT );   //IBFX=50.00
   
   if(Selllots < minAllowedLot)
      Selllots = minAllowedLot;
   if(Buylots > maxAllowedLot)
      Buylots = maxAllowedLot;
*/

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment ("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()

{
//----
   if(IsNewBar())
   {
      if(IsProfitOnBar())
         unprofitBars=0;
      else
         unprofitBars++;
   }

   if(useTrailingStop)
      if(!TrailingStopCheck())
         return(0);
           
//-------------------------------------------
/*
datetime now = TimeCurrent(),
         tM5= now - now % 300;
if (barTimeM5 == tM5) return; barTimeM5 = tM5;
// start of a new M30 bar.
*/
//---------------------------------------------------------------------------------------++
// Get calculation for Main Pair
   string CondB1 = "", CondS1 = "";
   string CondB2 = "", CondS2 = "";
   string CondB3 = "", CondS3 = "";
   string CondB4 = "", CondS4 = "";
   string CondB5 = "", CondS5 = "";
   string CondB6 = "", CondS6 = "";
   string CondB7 = "", CondS7 = "";
/*
   double EUR = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",0,0);
   double GBP = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",1,0);
   double USD = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",2,0);
   double JPY = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",3,0);
   double AUD = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",4,0);
   double NZD = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",5,0);
   double CAD = iCustom(NULL,0,"#ConsoleFU-TOT-testX2",6,0);

   double EUR1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",1,0);
   double GBP1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",0,0);
   double USD1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",2,0);
   double JPY1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",3,0);
   double AUD1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",4,0);
   double NZD1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",5,0);
   double CAD1 = iCustom(NULL,0,"#ConsoleTrendHL 1.01",6,0);
*/

    gv_euraud = GlobalVariableGet( "GV_euraud");
    gv_eurnzd = GlobalVariableGet( "GV_eurnzd");
    gv_eurusd = GlobalVariableGet( "GV_eurusd");
    gv_eurjpy = GlobalVariableGet( "GV_eurjpy");
    gv_eurcad = GlobalVariableGet( "GV_eurcad");
    gv_gbpaud = GlobalVariableGet( "GV_gbpaud");
    gv_gbpnzd = GlobalVariableGet( "GV_gbpnzd");
    gv_gbpusd = GlobalVariableGet( "GV_gbpusd");
    gv_gbpjpy = GlobalVariableGet( "GV_gbpjpy");
    gv_gbpcad = GlobalVariableGet( "GV_gbpcad");

    gvta_euraud = GlobalVariableGet( "GVTA_euraud");
    gvta_eurnzd = GlobalVariableGet( "GVTA_eurnzd");
    gvta_eurusd = GlobalVariableGet( "GVTA_eurusd");
    gvta_eurjpy = GlobalVariableGet( "GVTA_eurjpy");
    gvta_eurcad = GlobalVariableGet( "GVTA_eurcad");
    gvta_gbpaud = GlobalVariableGet( "GVTA_gbpaud");
    gvta_gbpnzd = GlobalVariableGet( "GVTA_gbpnzd");
    gvta_gbpusd = GlobalVariableGet( "GVTA_gbpusd");
    gvta_gbpjpy = GlobalVariableGet( "GVTA_gbpjpy");
    gvta_gbpcad = GlobalVariableGet( "GVTA_gbpcad");

//-----------------------
// Calculate TRENDING FOR THE PAST 15 MINUTES --------------

         
///////////////////////////////VERIABLE BUY CONDITON ///////////////////////////////////////////////////////////////////

         //if (GBP>JPY && GBP1>JPY1)
         if (gv_gbpjpy == 1 && gvta_gbpjpy == 1)
         {
         CondB1 = "Condition GBPJPY Buy OK";
         //CloseOrderCheck("GBPJPY",OP_SELL,Buylots, slipageOrder);
         //ManageBuy("GBPJPY",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }

         //if (GBP>AUD && GBP1>AUD1)
         if (gv_gbpaud == 1 && gvta_gbpaud == 1)
         {
         CondB1 = "Condition GBPAUD Buy OK";
         CloseOrderCheck("GBPAUD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPAUD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         //if (GBP>NZD && GBP1>NZD1)
         if (gv_gbpnzd == 1 && gvta_gbpnzd == 1)
         {
         CondB2 = "Condition GBPNZD Buy OK";
         CloseOrderCheck("GBPNZD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPNZD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         //if (GBP>CAD && GBP1>CAD1)
         if (gv_gbpcad == 1 && gvta_gbpcad == 1)
         {
         CondB3 = "Condition GBPCAD Buy OK";
         CloseOrderCheck("GBPCAD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPCAD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
        } 
//------------------------------------------------         
         //if (EUR>JPY && EUR1>JPY1)
         if (gv_eurjpy == 1 && gvta_eurjpy == 1)
         {
         CondB4 = "Condition EURAUD Buy OK";
         //CloseOrderCheck("EURAUD",OP_SELL,Buylots, slipageOrder);
         //ManageBuy("EURJPY",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }

         //if (EUR>AUD && EUR1>AUD1)
         if (gv_euraud == 1 && gvta_euraud == 1)
         {
         CondB4 = "Condition EURAUD Buy OK";
         CloseOrderCheck("EURAUD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURAUD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         //if (EUR>NZD && USD>NZD)
         if (gv_eurnzd == 1 && gvta_eurnzd == 1)
         {
         CondB5 = "Condition EURNZD Buy OK";
         CloseOrderCheck("EURNZD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURNZD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         //if (EUR>CAD && EUR1>CAD1)
         if (gv_eurcad == 1 && gvta_eurcad == 1)
         {
         CondB6 = "Condition EURCAD Buy OK";
         CloseOrderCheck("EURCAD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURCAD",OP_BUY,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
        }
///////////////////////////////VERIABLE SELL CONDITON ///////////////////////////////////////////////////////////////////

         //if (GBP<JPY && GBP1<JPY1)
         if (gv_gbpjpy == -1 && gvta_gbpjpy == -1)
         CondS1 = "Condition GBPJPY Sell OK";
         //CloseOrderCheck("GBPJPY",OP_BUY,Buylots, slipageOrder);
         //ManageSell("GBPJPY",OP_SELL,Buylots,0,0,slipageOrder,magicNumber,"EA Console");

         //if (GBP<AUD && GBP1<AUD1)
         if (gv_gbpaud == -1 && gvta_gbpaud == -1)
         CondS1 = "Condition GBPAUD Sell OK";
         CloseOrderCheck("GBPAUD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPAUD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");

         //if (GBP<NZD && GBP1<NZD1)
         if (gv_gbpnzd == -1 && gvta_gbpnzd == -1)
         CondS2 = "Condition GBPNZD Sell OK";
         CloseOrderCheck("GBPNZD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPNZD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");

         //if (GBP<CAD && GBP1<CAD1)
         if (gv_gbpcad == -1 && gvta_gbpcad == -1)
         CondS3 = "Condition GBPCAD Sell OK";
         CloseOrderCheck("GBPCAD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPCAD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
//------------------

         //if (EUR<JPY && EUR1<JPY1)
         if (gv_eurjpy == -1 && gvta_eurjpy == -1)
         CondS4 = "Condition EURJPY Sell OK";
         //CloseOrderCheck("EURJPY",OP_BUY,Buylots, slipageOrder);
         //ManageSell("EURJPY",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");

         //if (EUR<AUD && EUR1<AUD1)
         if (gv_euraud == -1 && gvta_euraud == -1)
         CondS4 = "Condition EURAUD Sell OK";
         CloseOrderCheck("EURAUD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURAUD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");

         //if (EUR<NZD && EUR1<NZD1)
         if (gv_eurnzd == -1 && gvta_eurnzd == -1)
         CondS5 = "Condition EURNZD Sell OK";
         CloseOrderCheck("EURNZD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURNZD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");

         //if (EUR<CAD && EUR1<CAD1)
         if (gv_eurcad == -1 && gvta_eurcad == -1)
         CondS6 = "Condition EURCAD Sell OK";
         CloseOrderCheck("EURCAD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURCAD",OP_SELL,Buylots,takeProfit,stopLoss,slipageOrder,magicNumber,"EA Console");
//=================================================================================================

   Comment (CondB1 + "         " + CondB2 + "          " + CondB3 + "            " + "\n" +
            CondB4 + "         " + CondB5 + "          " + CondB6 + "            " + "\n" +
            CondS1 + "         " + CondS2 + "          " + CondS3 + "            " + "\n" +
            CondS4 + "         " + CondS5 + "          " + CondS6 + "            " 
            );
//----
   return(0);
}


//////////////////////////////////////////////////////////////////////////////////////////////////  

//bool CloseOrderCheck()
void CloseOrderCheck(string symb, int dir, double lt, int slp)

{

    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);

   int total=OpenTradesForMNandPairType(magicNumber, symb);
   for(int cnt=total-1;cnt>=0;cnt--)
    {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==symb                   // check for symbol
         && (OrderMagicNumber() == magicNumber||OrderMagicNumber() == 0))        //  my magic number  && manual trades

      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be closed?                       
            if (Order == SIGNAL_CLOSEBUY)
            {
               if(OrderClose(OrderTicket(),OrderLots(),bid,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseBuy order : ", OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
               PlaySound("work.wav") ;
                  //return (true);
               }
               //return(false);
            } 
         }
         else // go to short position
         {
            // should it be closed?        
            if(Order == SIGNAL_CLOSESELL)
            {
               if(OrderClose(OrderTicket(),OrderLots(),ask,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseSell order : ",  OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
                PlaySound("work.wav") ;
                  //return (true);  
               }
               //return(false);
            }          
         }
      }
   }
   //return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//bool OpenOrderCheck()

void ManageBuy(string symb,int dir, double lt,double takeProfit,double stopLoss,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);
   stopLoss       = pips2dbl*stop_loss;
   takeProfit    = pips2dbl*take_profit;

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);
   
   if(total<BuymaxTrades)
   {
      // check for long position (BUY) possibility
     if(dir == OP_BUY)
      {
         ticket=OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfit,"EA Console",magicNumber,0,Green);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
            {
             //  buyBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-BUY order opened : ", symb,OrderOpenPrice());
               Alert (GetLastError());                      // Error message
              // return (true);
            }
         }
         else 
         {
         if(OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfit,"EA Console",magicNumber,0,Green) < 0) 
         Alert("Error opening position # ", GetLastError());
        // return(0);
//         Alert("Error opening BUY order : ",GetLastError());   
//         return(false);
         }   
      }
    }
}
//-----------------------------------------------------------------------------------------------------------------------
void ManageSell(string symb,int dir,double lt,double takeProfit,double stopLoss,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);
   stopLoss       = pips2dbl*stop_loss;
   takeProfit    = pips2dbl*take_profit;

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);

   if(total<SellmaxTrades)
   {
      // check for short position (SELL) possibility
    if(dir == OP_SELL)
      {
         ticket=OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfit,"EA Console",magicNumber,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            { 
             //  sellBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-SELL order opened : ",symb, OrderOpenPrice());
               Alert (GetLastError());                      // Error message
               //return (true);
            }
         }
         else
         {
         if (OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfit,"EA Console",magicNumber,0,Red)<0)
         Alert("Error opening SELL order : ",GetLastError());
         //return (0); 
         } //return (false);
      }
   }
   //return (true);   
}

//////////////////////////////////////////////////////////////////////////////////////////////////
bool TrailingStopCheck()
{  
   double newStopLoss;
   int total=OrdersTotal();
   for(int cnt=total-1;cnt>=0;cnt--)
   {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==symb                   // check for symbol
         && OrderMagicNumber() == magicNumber)        // my magic number
      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be modified? 
            newStopLoss = TrailingStopBuy();                      
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                   PlaySound("work.wav") ;
                   return (true);
               }
               return(false);
            } 
         }
         else // go to short position
         {
            // should it be modified? 
            newStopLoss = TrailingStopSell();        
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                  PlaySound("work.wav") ;
                  return (true);
               }
               return(false);
            }          
         }
      }
   }
   return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopBuy()
{
   double newStopLoss;
   double ask   =MarketInfo(symb,MODE_ASK);

   newStopLoss=ask-stopLoss;
   if((newStopLoss-trailingStop)>OrderStopLoss())
      return (newStopLoss);
   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopSell()
{
   double newStopLoss;
   double bid   =MarketInfo(symb,MODE_BID);
   
   newStopLoss=bid+stopLoss;
   if((newStopLoss+trailingStop)<OrderStopLoss())
      return (newStopLoss);

   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
int OpenTradesForMNandPairType(int iMN, string symb)
{
   int icnt, itotal, retval;

   retval=0;
   itotal=OrdersTotal();

      for(icnt=itotal-1;icnt>=0;icnt--) // for loop
      {
         dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
         // check for opened position, symbol & MagicNumber
         if (OrderSymbol()== symb)
         {
            if (OrderMagicNumber()==iMN) 
               retval++;             
         } // sOrderSymbol
      } // for loop

   return(retval);
}

///////////////////////////////////////////////////////////////////////////////////////////////////



bool IsNewBar()
{
   if( barTime < Time[0]) 
   {
        // we have a new bar opened
      barTime = Time[0];
      return(true);
   }
   return (false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool IsProfitOnBar()
{
   int icnt, itotal;
   itotal=OrdersTotal();
   if(itotal==0)
      return(true);
      
   for(icnt=itotal-1;icnt>=0;icnt--) // for loop
   {
      dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      // check for opened position, symbol & MagicNumber
      if (OrderSymbol()== symb && OrderMagicNumber()==magicNumber)
      {
         if (OrderProfit()>0) 
            return(true);             
      } 
   } // for loop 
   return(false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool Crossed_GBPJPY (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPJPY is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPAUD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPAUD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPNZD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPNZD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPCAD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPCAD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//----------------------------
bool Crossed_EURJPY (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURJPY is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_EURAUD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURAUD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//---------------------------
bool Crossed_EURNZD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURNZD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//----------------------------
bool Crossed_EURCAD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURCAD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 


///////////////////////////////////////////////////////////////////////////////////////////////////
/*
bool AllowTradesByTime()
{
   int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; 
   if (Finish_Time == 0) Finish_Time = 24; 
   if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(0);
}
*/

